﻿#pragma once

#include "StoveSDKStruct.h"
#include "StoveSDKVersion.h"
#include "Engine.h"
#include "StoveSDKWebInterface.generated.h"

USTRUCT(BlueprintType)
struct FStoveCefHeader
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
        FString Name;

    UPROPERTY()
        FString Value;
};

USTRUCT(BlueprintType)
struct FStoveCefCookie
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
        FString Domain;

    UPROPERTY()
        FString Path;

    UPROPERTY()
        FString Name;

    UPROPERTY()
        FString Value;

    UPROPERTY()
        bool bHttpOnly;

    UPROPERTY()
        bool bSecure;

    UPROPERTY()
        int Expiration;
};

class IStoveSDKWebInterface
{
public:
    virtual ~IStoveSDKWebInterface() {};

    typedef TFunction<void(const FString& Name, const FString& Value, const FString& Id)> Notification;

    virtual void Create(TSharedPtr<SWidget>& WebViewWidget) = 0;
    virtual void Destroy() = 0;
    virtual void LoadURL(const FString& Url, const TArray<FStoveCefHeader>& Headers) = 0;
    virtual void Reload() = 0;
    virtual void GoBack() = 0;
    virtual void GoForward() = 0;
    virtual bool CanGoBack() = 0;
    virtual bool CanGoForward() = 0;
    virtual void GoHome() = 0;
    virtual void SetCookie(const FString& Url, const FStoveCefCookie& Cookie) = 0;
    virtual void DeleteCookie(const FString& Url, const FString& Name) = 0;
    virtual void RegisterNotificationListner(const Notification& Noti) = 0;
};

